# -*- coding: utf-8 -*-
import os
import time
import oss2

import parse_pji_image

key1 = 'pji/'
path1 = '/root/'
sleep_time = 2  # 每多少秒扫描一次


def parse_to_mp4(merged_bag_file_path, parse_prefix, local_parse_dir, local_delete_list):
    try:
        local_mp4_dir = parse_pji_image.parse(merged_bag_file_path, local_parse_dir)
        mp4_file_name = 'camera'
        local_mp4_file_path = local_mp4_dir + '/' + mp4_file_name + '.mp4'
        local_delete_list.append(local_mp4_file_path)
        oss_csv_object_key = parse_prefix + mp4_file_name + '.mp4'
        bucket.put_object_from_file(oss_csv_object_key, local_mp4_file_path)
    except Exception, e:
        # 当出现异常时执行的代码
        print "捕获到一个异常: %s" % str(e)


'''
cname：http://open-bucket.oss.icvdc.com
内网endpoint: oss-cn-beijing-gqzl-d01-a.ops.gqzl-cloud.com
oss桶名： open-bucket
keyid：n8glvFGS25MrLY7j
secret：xZ2Fozoarpfw0z28FUhtg8cu0yDc5d
'''
# ------- 获取合并之后的bag包，解析出csv -------
if __name__ == '__main__':
    # 1 创建阿里云对象
    auth = oss2.Auth('n8glvFGS25MrLY7j', 'xZ2Fozoarpfw0z28FUhtg8cu0yDc5d')
    # cname = 'http://open-bucket.oss.icvdc.com'
    # bucket = oss2.Bucket(auth, cname, 'open-bucket', is_cname=True)
    endpoint = 'oss-cn-beijing-gqzl-d01-a.ops.gqzl-cloud.com'
    bucket = oss2.Bucket(auth, endpoint, 'open-bucket')
    while True:
        local_delete_list = []
        oss_delete_list = []
        prefix_list = []
        # 2 获取已经上传完成的所有目录并分组
        for obj1 in oss2.ObjectIterator(bucket, prefix=key1):
            # 获取合并后的包
            merged_bag_object_key = str(obj1.key)
            # print(f'判断1{merged_bag_object_key}')
            if 'data_merge' in str(obj1.key) and str(obj1.key).endswith('.bag'):
                merged_bag_object_key_split = merged_bag_object_key.split('/')
                merged_prefix = '/'.join(merged_bag_object_key_split[:-1])
                parse_prefix = merged_prefix.replace('data_merge', 'data_parse')
                parse_prefix_full = merged_bag_object_key.replace('data_merge', 'data_parse')[:-4] + '/'
                camera_done = False
                for obj2 in oss2.ObjectIterator(bucket, prefix=parse_prefix_full):
                    if '/camera.mp4' in str(obj2.key):
                        print '%s 存在摄像头视频。' % str(obj2.key)
                        camera_done = True
                if camera_done:
                    print '%s 存在摄像头视频。' % parse_prefix_full
                    continue
                print '%s 不存在摄像头视频：' % parse_prefix_full
                # print(f'需要解析{merged_bag_object_key}')
                local_merged_bag_path = path1 + 'camera/' + merged_bag_object_key
                local_merged_dir = '/'.join(local_merged_bag_path.split('/')[:-1])
                local_parse_dir = local_merged_dir.replace('data_merge', 'data_parse')
                if not os.path.exists(local_merged_dir):
                    os.makedirs(local_merged_dir)
                if not os.path.exists(local_parse_dir):
                    os.makedirs(local_parse_dir)
                merged_bag_full_name = merged_bag_object_key_split[-1]
                merged_bag_name = merged_bag_full_name.split('.')[0]
                try:
                    bucket.get_object_to_file(merged_bag_object_key, local_merged_bag_path)
                except Exception as e:
                    print "下载合并后的bag包失败: %s" % str(e)
                    # print(f'删除本地临时文件{e}')

                local_delete_list.append(local_merged_bag_path)
                # 2 生成 pos_orig.csv 和 pos_hmi.csv
                print '生成视频：%s' % str(obj1.key)
                parse_to_mp4(local_merged_bag_path, parse_prefix_full, local_parse_dir, local_delete_list)

        # 删除本地临时文件
        if len(local_delete_list) > 0:
            for local_delete in local_delete_list:
                try:
                    os.remove(local_delete)
                except Exception as e:
                    print "捕获到一个异常: %s" % str(e)
                    # print(f'删除本地临时文件{e}')
        time.sleep(sleep_time)
